# bzt18uxa02

| bzt   | 1 | 8 | uxa | 02 |
|:-------------:|:-------------:|:-------------:|:-------------:|:-------------:| 
| Buzztime | 1Gb Ram | 8Gb eMMC | usb over audio | v2 |

v1(spartan) was never released.


# Build Steps

1. uboot  compile
```
make distclean
make clean
make rk3128_defconfig
make 
```

1. When finished, uboot.img and RK3128MiniLoaderAll_V2.31.bin will be created in u-boot root directory 
    Copy the results to the bzt18uxa02-kernel folder :
        ```
        cp u-boot/uboot.img device/buzztime/bzt18uxa02-kernel/
        cp RK3128MiniLoaderAll_V2.31.bin device/buzztime/bzt18uxa02-kernel/
        ```

2. kernel  compile
```
make rockchip_dy_defconfig
verify [Suport USB UART Bypass Function] is not checked  
  cd kernel  
  make menuconfig  
  System Type---> 
     [] Support USB UART Bypass Function
  <Save>, <Exit>
make rk3128-86v.img
```
if kernel was cleaned or build fails for missing gsl_point_id.o :  
`cp kernel/drivers/input/touchscreen/gsl_point_id.o.bak kernel/drivers/input/touchscreen/gsl_point.o`

    _Addendum:_  
    Duco team provided rk3128-86v_normal.dts with the following instructions:  
    copy the attached file (rk3128-86v_normal.dts) to kernel/arch/arm/boot/dts  
    run `make rk3128-86v_normal.img` when compiling the kernel
    _Post Addendum:_  
    Above change did not function correctly, revert to the prior instructions.  



1. When finished,  kernel.img, resource.img will be created in kernel root directory    
Copy the binary results from the u-boot and kernel builds to the bzt18uxa02-kernel folder :
    ```
    cp kernel/arch/arm/boot/zImage device/buzztime/bzt18uxa02-kernel/
    cp kernel/resource.img device/buzztime/bzt18uxa02-kernel/
    ```
The device/buzztime/bzt18uxa02-kernel/ folder is where the 'official' images are tagged and versioned.


3. Android  compile
SDK root directory provided build.sh script, it used for config the JDK7 environment variable, please config the JDK according to actual compile environment, and execute "make" command.

```
 source build/envsetup.sh
 lunch
```
choice bzt18uxa02-userdebug
°∞For example£∫
```
Lunch menu... pick a combo:
     1. aosp_arm-eng
     2. aosp_arm64-eng
     3. aosp_mips-eng
     4. aosp_mips64-eng
     5. aosp_x86-eng
     6. aosp_x86_64-eng
     7. mini_emulator_arm64-userdebug
     8. m_e_arm-userdebug
     9. mini_emulator_mips-userdebug
     10. mini_emulator_x86_64-userdebug
     11. mini_emulator_x86-userdebug
     12. rk312x-eng
     13. rk312x-user
     14. rk312x-userdebug

Which would you like? [aosp_arm-eng]
```

 `make -j8`

After completed compile, execute mkimage.sh script which under SDK root directory, it will create firmware to rockdev/Image-rk312x directory.
 
 5. Create firmware image
 TODO: bring this step up to speed.  Currently afptool,rkImageMaker, parameter.txt and package-file need to be copied into rockdev, but rockdev isn't created until the ./mkimage step.
 `./mkimage.sh`



## Repo Status 
as of rkimage build 5/30/2017


+ project RKTools/                                (*** NO BRANCH ***)
 + --	windows/AndroidTool.zip
 + -m	windows/AndroidTool/rockdev/rk312x.parameter.txt
+ project build/                                  (*** NO BRANCH ***)
 + -m	core/dumpvar.mk
 + -m	core/tasks/check_boot_jars/package_whitelist.txt
 + --	target/product/security/._media.pem
 + --	target/product/security/._platform.pem
 + --	target/product/security/._shared.pem
 + --	target/product/security/Android.mk
 + --	target/product/security/README
 + --	target/product/security/keys.tar.gz
 + --	target/product/security/media.pem
 + --	target/product/security/media.pk8
 + --	target/product/security/media.x509.pem
 + --	target/product/security/mkbuildkey.sh
 + --	target/product/security/mkkey.sh
 + --	target/product/security/platform.pem
 + --	target/product/security/platform.pk8
 + --	target/product/security/platform.x509.pem
 + --	target/product/security/privateKey.bin
 + --	target/product/security/publicKey.bin
 + --	target/product/security/releasekey.pem
 + --	target/product/security/releasekey.pk8
 + --	target/product/security/releasekey.x509.pem
 + --	target/product/security/shared.pem
 + --	target/product/security/shared.pk8
 + --	target/product/security/shared.x509.pem
 + --	target/product/security/testkey.pem
 + --	target/product/security/testkey.pk8
 + --	target/product/security/testkey.x509.pem
 + --	target/product/security/verity.pk8
 + --	target/product/security/verity.x509.pem
 + --	target/product/security/verity_key
 + R-	target/product/security/Android.mk => target/product/security_aosp/Android-aosp.mk (100%)
 + R-	target/product/security/README => target/product/security_aosp/README (100%)
 + R-	target/product/security/media.pem => target/product/security_aosp/media.pem (100%)
 + R-	target/product/security/media.pk8 => target/product/security_aosp/media.pk8 (100%)
 + R-	target/product/security/media.x509.pem => target/product/security_aosp/media.x509.pem (100%)
 + R-	target/product/security/mkkey.sh => target/product/security_aosp/mkkey.sh (100%)
 + R-	target/product/security/platform.pem => target/product/security_aosp/platform.pem (100%)
 + R-	target/product/security/platform.pk8 => target/product/security_aosp/platform.pk8 (100%)
 + R-	target/product/security/platform.x509.pem => target/product/security_aosp/platform.x509.pem (100%)
 + R-	target/product/security/shared.pem => target/product/security_aosp/shared.pem (100%)
 + R-	target/product/security/shared.pk8 => target/product/security_aosp/shared.pk8 (100%)
 + R-	target/product/security/shared.x509.pem => target/product/security_aosp/shared.x509.pem (100%)
 + R-	target/product/security/testkey.pem => target/product/security_aosp/testkey.pem (100%)
 + R-	target/product/security/testkey.pk8 => target/product/security_aosp/testkey.pk8 (100%)
 + R-	target/product/security/testkey.x509.pem => target/product/security_aosp/testkey.x509.pem (100%)
 + R-	target/product/security/verity.pk8 => target/product/security_aosp/verity.pk8 (100%)
 + R-	target/product/security/verity.x509.pem => target/product/security_aosp/verity.x509.pem (100%)
 + R-	target/product/security/verity_key => target/product/security_aosp/verity_key (100%)
 + -m	tools/buildinfo.sh
+ project device/common/                          (*** NO BRANCH ***)
 + -m	bluetooth/libbt-rtk/uart/include/bt_vendor_rtk.h
 + -m	populate-new-device.sh
+ project device/rockchip/common/                 (*** NO BRANCH ***)
 + -m	BoardConfig.mk
 + -m	common.mk
 + -m	device.mk
 + -m	init.rockchip.rc
 + --	nfc/nfc/libnfc-brcm.conf
 + --	nfc/nfc/libnfc-nxp.conf
 + --	nfc/nfc/libpn548ad_fw.so
 + -m	overlay/frameworks/base/core/res/res/values/config.xml
 + -m	sepolicy/file_contexts
+ project device/rockchip/rk312x/                 (*** NO BRANCH ***)
 + -m	AndroidProducts.mk
 + -m	BoardConfig.mk
 + -m	bluetooth/bdroid_buildcfg.h
 + --	bootanimation-scorpio.zip
 + --	bootanimation.zip
 + --	bzt18uxa02.mk
 + -m	rk312x.mk
 + -m	vendorsetup.sh
 + -m	wifi_bt.mk
+ project external/libnfc-nci/                    (*** NO BRANCH ***)
 + -m	Android.mk
 + --	CleanSpec.mk
 + -d	NOTICE
 + -d	README
 + --	README.md
 + -d	access_vectors
 + -d	adbd.te
 + -d	app.te
 + -d	attributes
 + -d	binderservicedomain.te
 + -d	blkid.te
 + -d	blkid_untrusted.te
 + -d	bluetooth.te
 + -d	bootanim.te
 + -d	clatd.te
 + -d	debuggerd.te
 + -d	device.te
 + -d	dex2oat.te
 + -d	dhcp.te
 + -d	dnsmasq.te
 + -d	domain.te
 + -d	drmserver.te
 + -d	dumpstate.te
 + -d	external_sepolicy-6.0开关机动画铃声.patch
 + -d	file.te
 + -d	file_contexts
 + -d	fingerprintd.te
 + -d	fs_use
 + -d	fsck.te
 + -d	fsck_untrusted.te
 + -d	gatekeeperd.te
 + -d	genfs_contexts
 + -d	global_macros
 + -d	gpsd.te
 + --	halimpl/Android.mk
 + --	halimpl/pn54x/Android.mk
 + --	halimpl/pn54x/common/phNfcCommon.h
 + --	halimpl/pn54x/common/phNfcCompId.h
 + --	halimpl/pn54x/common/phNfcStatus.h
 + --	halimpl/pn54x/common/phNfcTypes.h
 + --	halimpl/pn54x/configs/NXP_ESE_Features.h
 + --	halimpl/pn54x/configs/NXP_NFCC_Features.h
 + --	halimpl/pn54x/configs/NXP_Platform_Features.h
 + --	halimpl/pn54x/dnld/phDnldNfc.c
 + --	halimpl/pn54x/dnld/phDnldNfc.h
 + --	halimpl/pn54x/dnld/phDnldNfc_Cmd.h
 + --	halimpl/pn54x/dnld/phDnldNfc_Internal.c
 + --	halimpl/pn54x/dnld/phDnldNfc_Internal.h
 + --	halimpl/pn54x/dnld/phDnldNfc_Status.h
 + --	halimpl/pn54x/dnld/phDnldNfc_Utils.c
 + --	halimpl/pn54x/dnld/phDnldNfc_Utils.h
 + --	halimpl/pn54x/dnld/phNxpNciHal_Dnld.c
 + --	halimpl/pn54x/dnld/phNxpNciHal_Dnld.h
 + --	halimpl/pn54x/hal/phNxpNciHal.c
 + --	halimpl/pn54x/hal/phNxpNciHal.h
 + --	halimpl/pn54x/hal/phNxpNciHal_Kovio.c
 + --	halimpl/pn54x/hal/phNxpNciHal_Kovio.h
 + --	halimpl/pn54x/hal/phNxpNciHal_NfcDepSWPrio.c
 + --	halimpl/pn54x/hal/phNxpNciHal_NfcDepSWPrio.h
 + --	halimpl/pn54x/hal/phNxpNciHal_dta.c
 + --	halimpl/pn54x/hal/phNxpNciHal_dta.h
 + --	halimpl/pn54x/hal/phNxpNciHal_ext.c
 + --	halimpl/pn54x/hal/phNxpNciHal_ext.h
 + --	halimpl/pn54x/inc/phNxpNciHal_Adaptation.h
 + --	halimpl/pn54x/inc/phNxpNciHal_Api.h
 + --	halimpl/pn54x/inc/phNxpNciHal_SelfTest.h
 + --	halimpl/pn54x/libnfc-brcm.conf
 + --	halimpl/pn54x/libnfc-nxp-PN547C2_example.conf
 + --	halimpl/pn54x/libnfc-nxp-PN548C2_example.conf
 + --	halimpl/pn54x/libnfc-nxp-PN551_example.conf
 + --	halimpl/pn54x/libnfc-nxp-PN553_example.conf
 + --	halimpl/pn54x/libnfc-nxp-PN65T_example.conf
 + --	halimpl/pn54x/libnfc-nxp-PN66T_example.conf
 + --	halimpl/pn54x/libnfc-nxp-PN67T_example.conf
 + --	halimpl/pn54x/libnfc-nxp-PN80T_example.conf
 + --	halimpl/pn54x/log/phNxpLog.c
 + --	halimpl/pn54x/log/phNxpLog.h
 + --	halimpl/pn54x/nfc_nci.c
 + --	halimpl/pn54x/self-test/phNxpNciHal_SelfTest.c
 + --	halimpl/pn54x/tml/phDal4Nfc_messageQueueLib.c
 + --	halimpl/pn54x/tml/phDal4Nfc_messageQueueLib.h
 + --	halimpl/pn54x/tml/phOsalNfc_Timer.c
 + --	halimpl/pn54x/tml/phOsalNfc_Timer.h
 + --	halimpl/pn54x/tml/phTmlNfc.c
 + --	halimpl/pn54x/tml/phTmlNfc.h
 + --	halimpl/pn54x/tml/phTmlNfc_i2c.c
 + --	halimpl/pn54x/tml/phTmlNfc_i2c.h
 + --	halimpl/pn54x/utils/phNxpConfig.cpp
 + --	halimpl/pn54x/utils/phNxpConfig.h
 + --	halimpl/pn54x/utils/phNxpNciHal_utils.c
 + --	halimpl/pn54x/utils/phNxpNciHal_utils.h
 + -d	hci_attach.te
 + -d	healthd.te
 + -d	hostapd.te
 + -d	init.te
 + -d	initial_sid_contexts
 + -d	initial_sids
 + -d	inputflinger.te
 + -d	install_recovery.te
 + -d	installd.te
 + -d	ioctl_macros
 + -d	isolated_app.te
 + -d	kernel.te
 + -d	keys.conf
 + -d	keystore.te
 + -d	lmkd.te
 + -d	logd.te
 + -d	mac_permissions.xml
 + -d	mdnsd.te
 + -d	mediaserver.te
 + -d	mls
 + -d	mls_macros
 + -d	mtp.te
 + -d	net.te
 + -d	netd.te
 + -d	neverallow_macros
 + -d	nfc.te
 + -d	perfprofd.te
 + -d	platform_app.te
 + -d	policy_capabilities
 + -d	port_contexts
 + -d	ppp.te
 + -d	procrank.te
 + -d	property.te
 + -d	property_contexts
 + -d	racoon.te
 + -d	radio.te
 + -d	recovery.te
 + -d	rild.te
 + -d	roles
 + -d	runas.te
 + -d	sdcardd.te
 + -d	seapp_contexts
 + -d	security_classes
 + -d	service.te
 + -d	service_contexts
 + -d	servicemanager.te
 + -d	sgdisk.te
 + -d	shared_relro.te
 + -d	shell.te
 + -d	slideshow.te
 + --	src/adaptation/CrcChecksum.cpp
 + --	src/adaptation/NfcAdaptation.cpp
 + --	src/adaptation/OverrideLog.cpp
 + --	src/adaptation/android_logmsg.cpp
 + --	src/adaptation/config.cpp
 + --	src/adaptation/libmain.c
 + --	src/gki/common/gki.h
 + --	src/gki/common/gki_buffer.c
 + --	src/gki/common/gki_common.h
 + --	src/gki/common/gki_debug.c
 + --	src/gki/common/gki_inet.h
 + --	src/gki/common/gki_time.c
 + --	src/gki/ulinux/data_types.h
 + --	src/gki/ulinux/gki_int.h
 + --	src/gki/ulinux/gki_ulinux.c
 + --	src/hal/include/gki_hal_target.h
 + --	src/hal/include/nci_defs.h
 + --	src/hal/include/nfc_hal_api.h
 + --	src/hal/include/nfc_hal_target.h
 + --	src/hal/include/nfc_types.h
 + --	src/hal/int/nfc_brcm_defs.h
 + --	src/hal/int/nfc_hal_int.h
 + --	src/hal/int/nfc_hal_int_api.h
 + --	src/hal/int/nfc_hal_nv_ci.h
 + --	src/hal/int/nfc_hal_nv_co.h
 + --	src/hal/int/nfc_hal_post_reset.h
 + --	src/include/CrcChecksum.h
 + --	src/include/NXP_ESE_Features.h
 + --	src/include/NXP_NFCC_Features.h
 + --	src/include/NXP_Platform_Features.h
 + --	src/include/NfcAdaptation.h
 + --	src/include/OverrideLog.h
 + --	src/include/android_logmsg.h
 + --	src/include/bt_target.h
 + --	src/include/bt_trace.h
 + --	src/include/bt_types.h
 + --	src/include/btu_api.h
 + --	src/include/buildcfg.h
 + --	src/include/buildcfg_hal.h
 + --	src/include/config.h
 + --	src/include/dyn_mem.h
 + --	src/include/gki_target.h
 + --	src/include/hcidefs.h
 + --	src/include/nfc_target.h
 + --	src/include/trace_api.h
 + --	src/include/vendor_cfg.h
 + --	src/nfa/ce/nfa_ce_act.c
 + --	src/nfa/ce/nfa_ce_api.c
 + --	src/nfa/ce/nfa_ce_main.c
 + --	src/nfa/dm/nfa_dm_act.c
 + --	src/nfa/dm/nfa_dm_api.c
 + --	src/nfa/dm/nfa_dm_cfg.c
 + --	src/nfa/dm/nfa_dm_discover.c
 + --	src/nfa/dm/nfa_dm_main.c
 + --	src/nfa/dm/nfa_dm_ndef.c
 + --	src/nfa/ee/nfa_ee_act.c
 + --	src/nfa/ee/nfa_ee_api.c
 + --	src/nfa/ee/nfa_ee_main.c
 + --	src/nfa/hci/nfa_hci_act.c
 + --	src/nfa/hci/nfa_hci_api.c
 + --	src/nfa/hci/nfa_hci_ci.c
 + --	src/nfa/hci/nfa_hci_main.c
 + --	src/nfa/hci/nfa_hci_utils.c
 + --	src/nfa/include/nfa_api.h
 + --	src/nfa/include/nfa_ce_api.h
 + --	src/nfa/include/nfa_cho_api.h
 + --	src/nfa/include/nfa_ee_api.h
 + --	src/nfa/include/nfa_hci_api.h
 + --	src/nfa/include/nfa_hci_defs.h
 + --	src/nfa/include/nfa_mem_co.h
 + --	src/nfa/include/nfa_nv_ci.h
 + --	src/nfa/include/nfa_nv_co.h
 + --	src/nfa/include/nfa_p2p_api.h
 + --	src/nfa/include/nfa_rw_api.h
 + --	src/nfa/include/nfa_snep_api.h
 + --	src/nfa/int/nfa_ce_int.h
 + --	src/nfa/int/nfa_cho_int.h
 + --	src/nfa/int/nfa_dm_int.h
 + --	src/nfa/int/nfa_dta_int.h
 + --	src/nfa/int/nfa_ee_int.h
 + --	src/nfa/int/nfa_hci_int.h
 + --	src/nfa/int/nfa_p2p_int.h
 + --	src/nfa/int/nfa_rw_int.h
 + --	src/nfa/int/nfa_snep_int.h
 + --	src/nfa/int/nfa_sys.h
 + --	src/nfa/int/nfa_sys_int.h
 + --	src/nfa/int/nfa_sys_ptim.h
 + --	src/nfa/p2p/nfa_p2p_act.c
 + --	src/nfa/p2p/nfa_p2p_api.c
 + --	src/nfa/p2p/nfa_p2p_main.c
 + --	src/nfa/rw/nfa_rw_act.c
 + --	src/nfa/rw/nfa_rw_api.c
 + --	src/nfa/rw/nfa_rw_main.c
 + --	src/nfa/sys/nfa_sys_cback.c
 + --	src/nfa/sys/nfa_sys_cfg.c
 + --	src/nfa/sys/nfa_sys_main.c
 + --	src/nfa/sys/nfa_sys_ptim.c
 + --	src/nfc/include/ce_api.h
 + --	src/nfc/include/llcp_api.h
 + --	src/nfc/include/llcp_defs.h
 + --	src/nfc/include/nci_hmsgs.h
 + --	src/nfc/include/ndef_utils.h
 + --	src/nfc/include/nfc_api.h
 + --	src/nfc/include/rw_api.h
 + --	src/nfc/include/tags_defs.h
 + --	src/nfc/int/ce_int.h
 + --	src/nfc/int/llcp_int.h
 + --	src/nfc/int/nfc_int.h
 + --	src/nfc/int/rw_int.h
 + --	src/nfc/int/tags_int.h
 + --	src/nfc/llcp/llcp_api.c
 + --	src/nfc/llcp/llcp_dlc.c
 + --	src/nfc/llcp/llcp_link.c
 + --	src/nfc/llcp/llcp_main.c
 + --	src/nfc/llcp/llcp_sdp.c
 + --	src/nfc/llcp/llcp_util.c
 + --	src/nfc/nci/nci_hmsgs.c
 + --	src/nfc/nci/nci_hrcv.c
 + --	src/nfc/ndef/ndef_cho_utils.c
 + --	src/nfc/ndef/ndef_utils.c
 + --	src/nfc/nfc/nfc_ee.c
 + --	src/nfc/nfc/nfc_main.c
 + --	src/nfc/nfc/nfc_ncif.c
 + --	src/nfc/nfc/nfc_task.c
 + --	src/nfc/nfc/nfc_test.c
 + --	src/nfc/nfc/nfc_utils.c
 + --	src/nfc/nfc/nfc_vs.c
 + --	src/nfc/tags/ce_main.c
 + --	src/nfc/tags/ce_t3t.c
 + --	src/nfc/tags/ce_t4t.c
 + --	src/nfc/tags/rw_i93.c
 + --	src/nfc/tags/rw_main.c
 + --	src/nfc/tags/rw_t1t.c
 + --	src/nfc/tags/rw_t1t_ndef.c
 + --	src/nfc/tags/rw_t2t.c
 + --	src/nfc/tags/rw_t2t_ndef.c
 + --	src/nfc/tags/rw_t3t.c
 + --	src/nfc/tags/rw_t4t.c
 + --	src/nfc/tags/tags_int.c
 + --	src/nfca_version.c
 + --	src/static-lib-adapt/ProtoDispBluetoothHci.c
 + --	src/udrv/include/uamp_api.h
 + --	src/udrv/include/ucodec.h
 + --	src/udrv/include/udac.h
 + --	src/udrv/include/uipc.h
 + --	src/udrv/include/unv.h
 + --	src/udrv/include/upio.h
 + --	src/udrv/include/usb.h
 + --	src/udrv/include/utimer.h
 + --	src/udrv/include/uusb.h
 + -d	su.te
 + -d	surfaceflinger.te
 + -d	system_app.te
 + -d	system_server.te
 + -d	te_macros
 + -d	tee.te
 + -d	toolbox.te
 + -d	tools/Android.mk
 + -d	tools/README
 + -d	tools/check_seapp.c
 + -d	tools/checkfc.c
 + -d	tools/insertkeys.py
 + -d	tools/post_process_mac_perms
 + -d	tools/sepolicy-analyze/Android.mk
 + -d	tools/sepolicy-analyze/README
 + -d	tools/sepolicy-analyze/attribute.c
 + -d	tools/sepolicy-analyze/attribute.h
 + -d	tools/sepolicy-analyze/booleans.c
 + -d	tools/sepolicy-analyze/booleans.h
 + -d	tools/sepolicy-analyze/dups.c
 + -d	tools/sepolicy-analyze/dups.h
 + -d	tools/sepolicy-analyze/neverallow.c
 + -d	tools/sepolicy-analyze/neverallow.h
 + -d	tools/sepolicy-analyze/perm.c
 + -d	tools/sepolicy-analyze/perm.h
 + -d	tools/sepolicy-analyze/sepolicy-analyze.c
 + -d	tools/sepolicy-analyze/typecmp.c
 + -d	tools/sepolicy-analyze/typecmp.h
 + -d	tools/sepolicy-analyze/utils.c
 + -d	tools/sepolicy-analyze/utils.h
 + -d	tools/sepolicy-check.c
 + -d	tzdatacheck.te
 + -d	ueventd.te
 + -d	uncrypt.te
 + -d	untrusted_app.te
 + -d	users
 + -d	vdc.te
 + -d	vold.te
 + -d	watchdogd.te
 + -d	wpa.te
 + -d	zygote.te
+ project external/rk-pcba-test/                  (*** NO BRANCH ***)
 + -m	res/test_config.cfg
+ project frameworks/av/                          branch scorpio-duco-6.0.1
+ project frameworks/base/                        (*** NO BRANCH ***)
 + -m	Android.mk
 + --	README.md
 + -m	api/current.txt
 + -m	api/system-current.txt
 + -m	core/java/android/content/pm/PackageManager.java
 + -m	core/java/android/nfc/ApduList.aidl
 + -m	core/java/android/nfc/ApduList.java
 + -m	core/java/android/nfc/BeamShareData.aidl
 + -m	core/java/android/nfc/BeamShareData.java
 + -m	core/java/android/nfc/ErrorCodes.java
 + -m	core/java/android/nfc/FormatException.java
 + -m	core/java/android/nfc/IAppCallback.aidl
 + -m	core/java/android/nfc/INfcAdapter.aidl
 + -m	core/java/android/nfc/INfcAdapterExtras.aidl
 + -m	core/java/android/nfc/INfcCardEmulation.aidl
 + --	core/java/android/nfc/INfcFCardEmulation.aidl
 + -m	core/java/android/nfc/INfcTag.aidl
 + -m	core/java/android/nfc/INfcUnlockHandler.aidl
 + -m	core/java/android/nfc/NdefMessage.aidl
 + -m	core/java/android/nfc/NdefMessage.java
 + -m	core/java/android/nfc/NdefRecord.aidl
 + -m	core/java/android/nfc/NdefRecord.java
 + -m	core/java/android/nfc/NfcActivityManager.java
 + -m	core/java/android/nfc/NfcAdapter.java
 + -m	core/java/android/nfc/NfcEvent.java
 + -m	core/java/android/nfc/NfcManager.java
 + -m	core/java/android/nfc/Tag.aidl
 + -m	core/java/android/nfc/Tag.java
 + -m	core/java/android/nfc/TagLostException.java
 + -m	core/java/android/nfc/TechListParcel.aidl
 + -m	core/java/android/nfc/TechListParcel.java
 + -m	core/java/android/nfc/TransceiveResult.aidl
 + -m	core/java/android/nfc/TransceiveResult.java
 + -m	core/java/android/nfc/cardemulation/AidGroup.aidl
 + -m	core/java/android/nfc/cardemulation/AidGroup.java
 + -m	core/java/android/nfc/cardemulation/ApduServiceInfo.aidl
 + -m	core/java/android/nfc/cardemulation/ApduServiceInfo.java
 + -m	core/java/android/nfc/cardemulation/CardEmulation.java
 + -m	core/java/android/nfc/cardemulation/HostApduService.java
 + --	core/java/android/nfc/cardemulation/HostNfcFService.java
 + --	core/java/android/nfc/cardemulation/NfcFCardEmulation.java
 + --	core/java/android/nfc/cardemulation/NfcFServiceInfo.aidl
 + --	core/java/android/nfc/cardemulation/NfcFServiceInfo.java
 + -m	core/java/android/nfc/cardemulation/OffHostApduService.java
 + -m	core/java/android/nfc/package.html
 + -m	core/java/android/nfc/tech/BasicTagTechnology.java
 + -m	core/java/android/nfc/tech/IsoDep.java
 + -m	core/java/android/nfc/tech/MifareClassic.java
 + -m	core/java/android/nfc/tech/MifareUltralight.java
 + -m	core/java/android/nfc/tech/Ndef.java
 + -m	core/java/android/nfc/tech/NdefFormatable.java
 + -m	core/java/android/nfc/tech/NfcA.java
 + -m	core/java/android/nfc/tech/NfcB.java
 + -m	core/java/android/nfc/tech/NfcBarcode.java
 + -m	core/java/android/nfc/tech/NfcF.java
 + -m	core/java/android/nfc/tech/NfcV.java
 + -m	core/java/android/nfc/tech/TagTechnology.java
 + -m	core/java/android/nfc/tech/package.html
 + --	core/java/com/nxp/intf/IJcopService.aidl
 + --	core/java/com/nxp/intf/ILoaderService.aidl
 + --	core/java/com/nxp/intf/INxpExtrasService.aidl
 + --	core/java/com/nxp/intf/IeSEClientServicesAdapter.aidl
 + --	core/java/com/nxp/nfc/INfcDta.aidl
 + --	core/java/com/nxp/nfc/INfcVzw.aidl
 + --	core/java/com/nxp/nfc/INxpNfcAccessExtras.aidl
 + --	core/java/com/nxp/nfc/INxpNfcAdapter.aidl
 + --	core/java/com/nxp/nfc/INxpNfcAdapterExtras.aidl
 + --	core/java/com/nxp/nfc/NfcDta.java
 + --	core/java/com/nxp/nfc/NxpConstants.java
 + --	core/java/com/nxp/nfc/NxpNfcAdapter.java
 + --	core/java/com/nxp/nfc/gsma/internal/INxpNfcController.aidl
 + --	core/java/com/nxp/nfc/gsma/internal/NxpHandset.java
 + --	core/java/com/nxp/nfc/gsma/internal/NxpNfcController.java
 + --	core/java/com/nxp/nfc/gsma/internal/NxpOffHostService.java
 + --	core/java/com/vzw/nfc/AidFilter.java
 + --	core/java/com/vzw/nfc/RouteEntry.aidl
 + --	core/java/com/vzw/nfc/RouteEntry.java
 + --	core/java/com/vzw/nfc/dos/AidMaskDo.java
 + --	core/java/com/vzw/nfc/dos/AidRangeDo.java
 + --	core/java/com/vzw/nfc/dos/ClfFilterDo.java
 + --	core/java/com/vzw/nfc/dos/ClfFilterDoList.java
 + --	core/java/com/vzw/nfc/dos/DoParserException.java
 + --	core/java/com/vzw/nfc/dos/FilterConditionTagDo.java
 + --	core/java/com/vzw/nfc/dos/FilterEntryDo.java
 + --	core/java/com/vzw/nfc/dos/RoutingModeDo.java
 + --	core/java/com/vzw/nfc/dos/VzwPermissionDo.java
 + --	core/java/com/vzw/nfc/dos/VzwTlv.java
 + -m	core/res/res/values/attrs.xml
 + --	nxp-nfc-gsma/Android.mk
 + --	nxp-nfc-gsma/com.gsma.services.nfc.xml
 + --	nxp-nfc-gsma/java/com/gsma/services/nfc/AidGroup.java
 + --	nxp-nfc-gsma/java/com/gsma/services/nfc/NfcController.java
 + --	nxp-nfc-gsma/java/com/gsma/services/nfc/OffHostService.java
 + --	nxp-nfc-gsma/java/com/gsma/services/nfc/SEController.java
 + --	nxp-nfc-gsma/java/com/gsma/services/utils/Handset.java
 + --	nxp-nfc-gsma/java/com/gsma/services/utils/InsufficientResourcesException.java
 + -m	packages/SettingsProvider/res/values/defaults.xml
 + -m	packages/SystemUI/res/layout-sw600dp/navigation_bar.xml
 + -m	packages/SystemUI/res/layout/navigation_bar.xml
 + -m	packages/SystemUI/res/values/config.xml
 + -m	services/core/java/com/android/server/am/ActivityManagerService.java
+ project frameworks/native/                      (*** NO BRANCH ***)
 + --	data/etc/android.hardware.nfc.hcef.xml
+ project hardware/libhardware/                   (*** NO BRANCH ***)
 + -m	include/hardware/nfc.h
+ project kernel/                                 (*** NO BRANCH ***)
 + -m	arch/arm/boot/dts/lcd-ld089wu1-mipi.dtsi
 + --	arch/arm/boot/dts/lcd-ld089wu1-mipi_HW_NEW.dtsi
 + --	arch/arm/boot/dts/lcd-ld089wu1-mipi_pub.dtsi
 + --	arch/arm/boot/dts/rk3128-86v-bak.dts
 + -m	arch/arm/boot/dts/rk3128-86v.dts
 + --	arch/arm/boot/dts/rk3128-86v_jiangpin.dts
 + -m	arch/arm/boot/dts/rk3128-cif-sensor.dtsi
 + -m	arch/arm/boot/dts/rk312x-sdk.dtsi
 + -m	arch/arm/boot/dts/rk816.dtsi
 + --	arch/arm/configs/rockchip_dy_defconfig
 + -m	arch/arm/kernel/process.c
 + -m	arch/arm/mach-rockchip/ddr_freq.c
 + -m	arch/arm/mach-rockchip/dvfs.c
 + -m	arch/arm/mach-rockchip/pm-rk312x.c
 + -m	arch/arm/mach-rockchip/rk_camera_sensor_info.h
 + --	drivers/gpu/arm/mali400/mali/__malidrv_build_info.c
 + -m	drivers/headset_observe/rk_headset.c
 + -m	drivers/headset_observe/rockchip_headset_core.c
 + -m	drivers/i2c/busses/i2c-rockchip.c
 + -m	drivers/input/sensors/accel/Kconfig
 + -m	drivers/input/sensors/accel/Makefile
 + --	drivers/input/sensors/accel/bma2xx.c
 + -m	drivers/input/sensors/sensor-dev.c
 + --	drivers/input/touchscreen/-----gsl_point_id.c
 + -m	drivers/input/touchscreen/Makefile
 + -d	drivers/input/touchscreen/gsl_point_id.c
 + -m	drivers/input/touchscreen/rockchip_gslX680_rk3128.c
 + -m	drivers/input/touchscreen/rockchip_gslX680_rk3128.h
 + --	drivers/input/touchscreen/rockchip_gslX680_rk3128_6.0.c
 + --	drivers/input/touchscreen/rockchip_gslX680_rk3128_6.0.h
 + -m	drivers/media/video/Makefile
 + --	drivers/media/video/gc0312.c
 + --	drivers/media/video/gc2145.c
 + -m	drivers/mmc/host/rk_sdmmc.c
 + -m	drivers/nfc/Makefile
 + --	drivers/nfc/pn544.c
 + --	drivers/nfc/pn544.h
 + -m	drivers/power/rk816_battery.c
 + -m	drivers/power/rk816_battery.h
 + --	drivers/power/rk816_battery_bak.c
 + --	drivers/power/rk816_battery_bak.h
 + --	drivers/video/rockchip/rk_fb_ldo6.c
 + -m	include/linux/mfd/rk816.h
 + --	include/linux/mfd/rk816_bak.h
 + -m	include/linux/sensor-dev.h
 + -m	include/media/v4l2-chip-ident.h
 + --	kernel.img
 + --	lo-----go_kernel.bmp
 + --	lo----go.bmp
 + --	lo--buzztime--go.bmp
 + --	lo--buzztime--go_kernel.bmp
 + -m	logo.bmp
 + -m	logo_kernel.bmp
 + -m	net/rfkill/rfkill-bt.c
 + -m	net/rfkill/rfkill-wlan.c
 + --	nfc.config
 + --	nfc_ok.config
 + --	ok.config
 + --	resource.img
 + -m	sound/soc/codecs/rk312x_codec.c
 + --	sound/soc/codecs/rk312x_codec_pub.c
+ project packages/apps/Camera/                   (*** NO BRANCH ***)
 + -m	res/values/strings.xml
+ project packages/apps/Camera2/                  (*** NO BRANCH ***)
 + -m	res/values/strings.xml
+ project packages/apps/Nfc/                      (*** NO BRANCH ***)
 + -m	Android.mk
 + -m	AndroidManifest.xml
 + -m	CleanSpec.mk
 + --	README.md
 + -m	assets/star.png
 + -m	etc/sample_nfcee_access.xml
 + -m	migrate_nfc.txt
 + -m	nci/Android.mk
 + -m	nci/jni/Android.mk
 + -m	nci/jni/CondVar.cpp
 + -m	nci/jni/CondVar.h
 + -m	nci/jni/DataQueue.cpp
 + -m	nci/jni/DataQueue.h
 + --	nci/jni/DwpChannel.cpp
 + --	nci/jni/DwpChannel.h
 + --	nci/jni/HciRFParams.cpp
 + --	nci/jni/HciRFParams.h
 + -m	nci/jni/IntervalTimer.cpp
 + -m	nci/jni/IntervalTimer.h
 + -m	nci/jni/JavaClassConstants.h
 + -m	nci/jni/Mutex.cpp
 + -m	nci/jni/Mutex.h
 + -m	nci/jni/NativeLlcpConnectionlessSocket.cpp
 + -m	nci/jni/NativeLlcpServiceSocket.cpp
 + -m	nci/jni/NativeLlcpSocket.cpp
 + --	nci/jni/NativeNfcAla.cpp
 + -m	nci/jni/NativeNfcManager.cpp
 + -m	nci/jni/NativeNfcTag.cpp
 + --	nci/jni/NativeNxpFeature.cpp
 + -m	nci/jni/NativeP2pDevice.cpp
 + --	nci/jni/NativeSecureElement.cpp
 + -m	nci/jni/NfcJniUtil.cpp
 + -m	nci/jni/NfcJniUtil.h
 + -m	nci/jni/NfcTag.cpp
 + -m	nci/jni/NfcTag.h
 + -m	nci/jni/PeerToPeer.cpp
 + -m	nci/jni/PeerToPeer.h
 + -m	nci/jni/Pn544Interop.cpp
 + -m	nci/jni/Pn544Interop.h
 + -m	nci/jni/PowerSwitch.cpp
 + -m	nci/jni/RouteDataSet.cpp
 + -m	nci/jni/RouteDataSet.h
 + -m	nci/jni/RoutingManager.cpp
 + -m	nci/jni/RoutingManager.h
 + --	nci/jni/SecureElement.cpp
 + --	nci/jni/SecureElement.h
 + -m	nci/jni/SyncEvent.h
 + -m	nci/jni/extns/pn54x/src/common/phNciNfcTypes.h
 + -m	nci/jni/extns/pn54x/src/common/phNfcTypes.h
 + -m	nci/jni/extns/pn54x/src/log/phNxpLog.c
 + -m	nci/jni/extns/pn54x/src/log/phNxpLog.h
 + -m	nci/jni/extns/pn54x/src/mifare/phFriNfc_MifareStdMap.c
 + --	nci/jni/extns/pn54x/src/mifare/phFriNfc_MifareStdTimer.c
 + --	nci/jni/extns/pn54x/src/mifare/phFriNfc_MifareStdTimer.h
 + -m	nci/jni/extns/pn54x/src/mifare/phNxpExtns_MifareStd.c
 + -m	nci/jni/extns/pn54x/src/mifare/phNxpExtns_MifareStd.h
 + -m	nci/jni/extns/pn54x/src/phNxpExtns.c
 + -m	nci/jni/extns/pn54x/src/utils/phNxpConfig.cpp
 + -m	nci/jni/extns/pn54x/src/utils/phNxpConfig.h
 + --	nci/src/com/android/nfc/dhimpl/NativeNfcAla.java
 + -m	nci/src/com/android/nfc/dhimpl/NativeNfcManager.java
 + --	nci/src/com/android/nfc/dhimpl/NativeNfcSecureElement.java
 + -m	nci/src/com/android/nfc/dhimpl/NativeNfcTag.java
 + --	nci/src/com/gsma/nfc/internal/NxpNfcController.java
 + --	nci/src/com/gsma/nfc/internal/RegisteredNxpServicesCache.java
 + -m	nxp/Android.mk
 + -m	nxp/jni/Android.mk
 + -m	nxp/jni/com_android_nfc.cpp
 + -m	nxp/jni/com_android_nfc.h
 + -m	nxp/jni/com_android_nfc_NativeLlcpConnectionlessSocket.cpp
 + -m	nxp/jni/com_android_nfc_NativeLlcpServiceSocket.cpp
 + -m	nxp/jni/com_android_nfc_NativeLlcpSocket.cpp
 + -m	nxp/jni/com_android_nfc_NativeNfcManager.cpp
 + --	nxp/jni/com_android_nfc_NativeNfcSecureElement.cpp
 + -m	nxp/jni/com_android_nfc_NativeNfcTag.cpp
 + -m	nxp/jni/com_android_nfc_NativeP2pDevice.cpp
 + -m	nxp/jni/com_android_nfc_list.cpp
 + -m	nxp/jni/com_android_nfc_list.h
 + -m	nxp/src/com/android/nfc/dhimpl/NativeNfcManager.java
 + --	nxp/src/com/android/nfc/dhimpl/NativeNfcSecureElement.java
 + -m	nxp/src/com/android/nfc/dhimpl/NativeNfcTag.java
 + -m	res/drawable-hdpi/ic_menu_cancel_holo_dark.png
 + -m	res/drawable-hdpi/icon.png
 + -m	res/drawable-hdpi/nfc.png
 + -m	res/drawable-hdpi/tap_again.png
 + -m	res/drawable-mdpi/back.png
 + -m	res/drawable-mdpi/ic_menu_cancel_holo_dark.png
 + -m	res/drawable-mdpi/icon.png
 + -m	res/drawable-mdpi/tap_again.png
 + -m	res/drawable-xhdpi/icon.png
 + -m	res/drawable-xhdpi/tap_again.png
 + -m	res/drawable-xxhdpi/icon.png
 + -m	res/drawable-xxhdpi/tap_again.png
 + -m	res/drawable-xxxhdpi/icon.png
 + -m	res/layout/cardemu_item.xml
 + -m	res/layout/cardemu_payment_item.xml
 + -m	res/layout/cardemu_resolver.xml
 + -m	res/layout/screenshot.xml
 + -m	res/layout/tapagain.xml
 + -m	res/raw/end.ogg
 + -m	res/raw/error.ogg
 + -m	res/raw/start.ogg
 + -m	res/values-af/provisioning.xml
 + -m	res/values-af/strings.xml
 + -m	res/values-am/provisioning.xml
 + -m	res/values-am/strings.xml
 + -m	res/values-ar/provisioning.xml
 + -m	res/values-ar/strings.xml
 + -m	res/values-az-rAZ/provisioning.xml
 + -m	res/values-az-rAZ/strings.xml
 + -m	res/values-bg/provisioning.xml
 + -m	res/values-bg/strings.xml
 + -m	res/values-bn-rBD/provisioning.xml
 + -m	res/values-bn-rBD/strings.xml
 + -m	res/values-ca/provisioning.xml
 + -m	res/values-ca/strings.xml
 + -m	res/values-cs/provisioning.xml
 + -m	res/values-cs/strings.xml
 + -m	res/values-da/provisioning.xml
 + -m	res/values-da/strings.xml
 + -m	res/values-de/provisioning.xml
 + -m	res/values-de/strings.xml
 + -m	res/values-el/provisioning.xml
 + -m	res/values-el/strings.xml
 + -m	res/values-en-rAU/provisioning.xml
 + -m	res/values-en-rAU/strings.xml
 + -m	res/values-en-rGB/provisioning.xml
 + -m	res/values-en-rGB/strings.xml
 + -m	res/values-en-rIN/provisioning.xml
 + -m	res/values-en-rIN/strings.xml
 + -m	res/values-es-rUS/provisioning.xml
 + -m	res/values-es-rUS/strings.xml
 + -m	res/values-es/provisioning.xml
 + -m	res/values-es/strings.xml
 + -m	res/values-et-rEE/provisioning.xml
 + -m	res/values-et-rEE/strings.xml
 + -m	res/values-eu-rES/provisioning.xml
 + -m	res/values-eu-rES/strings.xml
 + -m	res/values-fa/provisioning.xml
 + -m	res/values-fa/strings.xml
 + -m	res/values-fi/provisioning.xml
 + -m	res/values-fi/strings.xml
 + -m	res/values-fr-rCA/provisioning.xml
 + -m	res/values-fr-rCA/strings.xml
 + -m	res/values-fr/provisioning.xml
 + -m	res/values-fr/strings.xml
 + -m	res/values-gl-rES/provisioning.xml
 + -m	res/values-gl-rES/strings.xml
 + -m	res/values-gu-rIN/provisioning.xml
 + -m	res/values-gu-rIN/strings.xml
 + -m	res/values-hi/provisioning.xml
 + -m	res/values-hi/strings.xml
 + -m	res/values-hr/provisioning.xml
 + -m	res/values-hr/strings.xml
 + -m	res/values-hu/provisioning.xml
 + -m	res/values-hu/strings.xml
 + -m	res/values-hy-rAM/provisioning.xml
 + -m	res/values-hy-rAM/strings.xml
 + -m	res/values-in/provisioning.xml
 + -m	res/values-in/strings.xml
 + -m	res/values-is-rIS/provisioning.xml
 + -m	res/values-is-rIS/strings.xml
 + -m	res/values-it/provisioning.xml
 + -m	res/values-it/strings.xml
 + -m	res/values-iw/provisioning.xml
 + -m	res/values-iw/strings.xml
 + -m	res/values-ja/provisioning.xml
 + -m	res/values-ja/strings.xml
 + -m	res/values-ka-rGE/provisioning.xml
 + -m	res/values-ka-rGE/strings.xml
 + -m	res/values-kk-rKZ/provisioning.xml
 + -m	res/values-kk-rKZ/strings.xml
 + -m	res/values-km-rKH/provisioning.xml
 + -m	res/values-km-rKH/strings.xml
 + -m	res/values-kn-rIN/provisioning.xml
 + -m	res/values-kn-rIN/strings.xml
 + -m	res/values-ko/provisioning.xml
 + -m	res/values-ko/strings.xml
 + -m	res/values-ky-rKG/provisioning.xml
 + -m	res/values-ky-rKG/strings.xml
 + -m	res/values-lo-rLA/provisioning.xml
 + -m	res/values-lo-rLA/strings.xml
 + -m	res/values-lt/provisioning.xml
 + -m	res/values-lt/strings.xml
 + -m	res/values-lv/provisioning.xml
 + -m	res/values-lv/strings.xml
 + -m	res/values-mk-rMK/provisioning.xml
 + -m	res/values-mk-rMK/strings.xml
 + -m	res/values-ml-rIN/provisioning.xml
 + -m	res/values-ml-rIN/strings.xml
 + -m	res/values-mn-rMN/provisioning.xml
 + -m	res/values-mn-rMN/strings.xml
 + -m	res/values-mr-rIN/provisioning.xml
 + -m	res/values-mr-rIN/strings.xml
 + -m	res/values-ms-rMY/provisioning.xml
 + -m	res/values-ms-rMY/strings.xml
 + -m	res/values-my-rMM/provisioning.xml
 + -m	res/values-my-rMM/strings.xml
 + -m	res/values-nb/provisioning.xml
 + -m	res/values-nb/strings.xml
 + -m	res/values-ne-rNP/provisioning.xml
 + -m	res/values-ne-rNP/strings.xml
 + -m	res/values-nl/provisioning.xml
 + -m	res/values-nl/strings.xml
 + -m	res/values-pa-rIN/provisioning.xml
 + -m	res/values-pa-rIN/strings.xml
 + -m	res/values-pl/provisioning.xml
 + -m	res/values-pl/strings.xml
 + -m	res/values-pt-rPT/provisioning.xml
 + -m	res/values-pt-rPT/strings.xml
 + -m	res/values-pt/provisioning.xml
 + -m	res/values-pt/strings.xml
 + -m	res/values-ro/provisioning.xml
 + -m	res/values-ro/strings.xml
 + -m	res/values-ru/provisioning.xml
 + -m	res/values-ru/strings.xml
 + -m	res/values-si-rLK/provisioning.xml
 + -m	res/values-si-rLK/strings.xml
 + -m	res/values-sk/provisioning.xml
 + -m	res/values-sk/strings.xml
 + -m	res/values-sl/provisioning.xml
 + -m	res/values-sl/strings.xml
 + -m	res/values-sq-rAL/provisioning.xml
 + -m	res/values-sq-rAL/strings.xml
 + -m	res/values-sr/provisioning.xml
 + -m	res/values-sr/strings.xml
 + -m	res/values-sv/provisioning.xml
 + -m	res/values-sv/strings.xml
 + -m	res/values-sw/provisioning.xml
 + -m	res/values-sw/strings.xml
 + -m	res/values-ta-rIN/provisioning.xml
 + -m	res/values-ta-rIN/strings.xml
 + -m	res/values-te-rIN/provisioning.xml
 + -m	res/values-te-rIN/strings.xml
 + -m	res/values-th/provisioning.xml
 + -m	res/values-th/strings.xml
 + -m	res/values-tl/provisioning.xml
 + -m	res/values-tl/strings.xml
 + -m	res/values-tr/provisioning.xml
 + -m	res/values-tr/strings.xml
 + -m	res/values-uk/provisioning.xml
 + -m	res/values-uk/strings.xml
 + -m	res/values-ur-rPK/provisioning.xml
 + -m	res/values-ur-rPK/strings.xml
 + -m	res/values-uz-rUZ/provisioning.xml
 + -m	res/values-uz-rUZ/strings.xml
 + -m	res/values-vi/provisioning.xml
 + -m	res/values-vi/strings.xml
 + -m	res/values-zh-rCN/provisioning.xml
 + -m	res/values-zh-rCN/strings.xml
 + -m	res/values-zh-rHK/provisioning.xml
 + -m	res/values-zh-rHK/strings.xml
 + -m	res/values-zh-rTW/provisioning.xml
 + -m	res/values-zh-rTW/strings.xml
 + -m	res/values-zu/provisioning.xml
 + -m	res/values-zu/strings.xml
 + -m	res/values/provisioning.xml
 + -m	res/values/strings.xml
 + -m	src/com/android/nfc/BeamShareActivity.java
 + -m	src/com/android/nfc/ConfirmConnectToWifiNetworkActivity.java
 + -m	src/com/android/nfc/DeviceHost.java
 + --	src/com/android/nfc/DtaServiceConnector.java
 + --	src/com/android/nfc/EnableNfcDialogActivity.java
 + -m	src/com/android/nfc/ForegroundUtils.java
 + -m	src/com/android/nfc/LlcpException.java
 + -m	src/com/android/nfc/LlcpPacket.java
 + -m	src/com/android/nfc/NfcApplication.java
 + -m	src/com/android/nfc/NfcBackupAgent.java
 + -m	src/com/android/nfc/NfcDiscoveryParameters.java
 + -m	src/com/android/nfc/NfcDispatcher.java
 + -m	src/com/android/nfc/NfcPermissions.java
 + -m	src/com/android/nfc/NfcRootActivity.java
 + --	src/com/android/nfc/NfcSccAccessControl.java
 + --	src/com/android/nfc/NfcSeAccessControl.java
 + -m	src/com/android/nfc/NfcService.java
 + -m	src/com/android/nfc/NfcUnlockManager.java
 + -m	src/com/android/nfc/NfcWifiProtectedSetup.java
 + -m	src/com/android/nfc/NfceeAccessControl.java
 + -m	src/com/android/nfc/P2pEventManager.java
 + -m	src/com/android/nfc/P2pLinkManager.java
 + -m	src/com/android/nfc/RegisteredComponentCache.java
 + -m	src/com/android/nfc/ScreenStateHelper.java
 + -m	src/com/android/nfc/TechListChooserActivity.java
 + -m	src/com/android/nfc/beam/BeamManager.java
 + -m	src/com/android/nfc/beam/BeamReceiveService.java
 + -m	src/com/android/nfc/beam/BeamSendService.java
 + -m	src/com/android/nfc/beam/BeamStatusReceiver.java
 + -m	src/com/android/nfc/beam/BeamTransferManager.java
 + -m	src/com/android/nfc/beam/BeamTransferRecord.aidl
 + -m	src/com/android/nfc/beam/BeamTransferRecord.java
 + -m	src/com/android/nfc/beam/BluetoothOppHandover.java
 + -m	src/com/android/nfc/beam/FireflyRenderer.java
 + -m	src/com/android/nfc/beam/MimeTypeUtil.java
 + -m	src/com/android/nfc/beam/SendUi.java
 + --	src/com/android/nfc/cardemulation/AidElement.java
 + -m	src/com/android/nfc/cardemulation/AidRoutingManager.java
 + -m	src/com/android/nfc/cardemulation/AppChooserActivity.java
 + -m	src/com/android/nfc/cardemulation/CardEmulationManager.java
 + -m	src/com/android/nfc/cardemulation/DefaultRemovedActivity.java
 + --	src/com/android/nfc/cardemulation/EnabledNfcFServices.java
 + -m	src/com/android/nfc/cardemulation/HostEmulationManager.java
 + --	src/com/android/nfc/cardemulation/HostNfcFEmulationManager.java
 + --	src/com/android/nfc/cardemulation/Nfcid2RoutingCache.java
 + --	src/com/android/nfc/cardemulation/Nfcid2RoutingManager.java
 + -m	src/com/android/nfc/cardemulation/PreferredServices.java
 + -m	src/com/android/nfc/cardemulation/RegisteredAidCache.java
 + --	src/com/android/nfc/cardemulation/RegisteredNfcFServicesCache.java
 + --	src/com/android/nfc/cardemulation/RegisteredNfcid2Cache.java
 + -m	src/com/android/nfc/cardemulation/RegisteredServicesCache.java
 + --	src/com/android/nfc/cardemulation/RegisteredT3tIdentifiersCache.java
 + --	src/com/android/nfc/cardemulation/SystemCodeRoutingManager.java
 + -m	src/com/android/nfc/cardemulation/TapAgainDialog.java
 + --	src/com/android/nfc/cardemulation/VzwRoutingCache.java
 + -m	src/com/android/nfc/echoserver/EchoServer.java
 + -m	src/com/android/nfc/handover/BluetoothPeripheralHandover.java
 + -m	src/com/android/nfc/handover/ConfirmConnectActivity.java
 + -m	src/com/android/nfc/handover/HandoverClient.java
 + -m	src/com/android/nfc/handover/HandoverDataParser.java
 + -m	src/com/android/nfc/handover/HandoverServer.java
 + -m	src/com/android/nfc/handover/PeripheralHandoverService.java
 + -m	src/com/android/nfc/ndefpush/NdefPushProtocol.java
 + -m	src/com/android/nfc/snep/SnepClient.java
 + -m	src/com/android/nfc/snep/SnepException.java
 + -m	src/com/android/nfc/snep/SnepMessage.java
 + -m	src/com/android/nfc/snep/SnepMessenger.java
 + -m	src/com/android/nfc/snep/SnepServer.java
 + --	src/com/android/nfc/sneptest/DtaSnepClient.java
 + --	src/com/android/nfc/sneptest/ExtDtaSnepServer.java
 + -m	tests/Android.mk
 + -m	tests/AndroidManifest.xml
 + -m	tests/src/com/android/nfc/MockLlcpSocket.java
 + -m	tests/src/com/android/nfc/snep/SnepBasicTests.java
 + -m	tests/src/com/android/nfc/snep/SnepCustomClientTests.java
 + -m	tests/src/com/android/nfc/snep/SnepDefaultClientTests.java
 + -m	tests/src/com/android/nfc/snep/SnepValidationClientTests.java
 + -m	tests/src/com/android/nfc/snep/SnepValidationServerTests.java
+ project packages/apps/Settings/                 (*** NO BRANCH ***)
 + -m	res/values/strings.xml
 + -m	src/com/android/settings/WirelessSettings.java
 + -m	src/com/android/settings/location/LocationMode.java
+ project system/core/                            (*** NO BRANCH ***)
 + -m	drmservice/drmservice.c
 + -m	healthd/healthd_mode_charger.cpp
+ project u-boot/                                 (*** NO BRANCH ***)
 + -m	arch/arm/cpu/armv7/rk32xx/lowlevel_init.S
 + -m	arch/arm/cpu/armv7/rk32xx/reset.c
 + -m	drivers/power/fuel_gauge/fg_rk816.c
 + --	drivers/power/fuel_gauge/fg_rk816_bak.c
 + -m	include/power/rk816_pmic.h
 + --	include/power/rk816_pmic_bak.h
+ project vendor/rockchip/common/                 (*** NO BRANCH ***)
 + -m	apps/RKUpdateService/Android.mk
 + -d	apps/RKUpdateService/RKUpdateService.apk
 + --	apps/RKUpdateService/RKUpdateServicePrebuilt.apk
 + --	apps/RKUpdateService/RKUpdateServicePrebuilt_box.apk
 + --	apps/RKUpdateService/RKUpdateServicePrebuilt_sofia.apk
 + -d	apps/RKUpdateService/RKUpdateService_box.apk
 + -d	apps/RKUpdateService/RKUpdateService_sofia.apk
 + -m	apps/apps.mk
