#!/bin/bash
pause()
{
#echo "Press any key to quit:"
#read -n1 -s key
exit 1
}

set -e

. build/envsetup.sh >/dev/null && setpaths

export PATH=$ANDROID_BUILD_PATHS:$PATH
TARGET_PRODUCT=`get_build_var TARGET_PRODUCT`
TARGET_HARDWARE=`get_build_var TARGET_BOARD_HARDWARE`
TARGET_DEVICE=`get_build_var TARGET_DEVICE`
TARGET_BUILD_VARIANT=`get_build_var TARGET_BUILD_VARIANT`

#Used to gather build information from files at root, building the BUILD_TAG
if [ -f  ${TARGET_PRODUCT}_build.id ]; then 
  BUILD_ID=`cat ${TARGET_PRODUCT}_build.id`
else
  BUILD_ID="0.1.0"
fi
if [ -f  ${TARGET_PRODUCT}_build_number.id ]; then 
  BUILD_NUMBER=`cat ${TARGET_PRODUCT}_build_number.id`
else
  BUILD_NUMBER="0000"
fi
BUILD_TAG="${BUILD_ID}-${BUILD_NUMBER}-${TARGET_BUILD_VARIANT}"

# used when we thought we could deliver updates in addition to full images
#OTA_PATH=../ota-$TARGET_PRODUCT/$BUILD_ID-$BUILD_NUMBER
IMAGE_PATH=rockdev/Image-$TARGET_PRODUCT

echo TARGET_PRODUCT=$TARGET_PRODUCT
echo BUILD_TAG=$BUILD_TAG
echo IMAGE_PATH=$IMAGE_PATH
echo TARGET_DEVICE=$TARGET_DEVICE

echo "start to make update.img..."
cd rockdev
if [ ! -f "parameter" ] && [ ! -f "$TARGET_PRODUCT.parameter.txt" ]; then
  echo "Error:No found parameter!"
  pause
fi
if [ ! -f "$TARGET_PRODUCT.package-file" ] && [ ! -f "${TARGET_PRODUCT}.${TARGET_BUILD_VARIANT}.package-file" ]; then
  echo "Error:No found package-file!"
  pause
fi

if [ -f "package-file" ]; then 
  echo "package-file exits, removing it..." 
  rm -f package-file 
fi

if [ -f "${TARGET_PRODUCT}.${TARGET_BUILD_VARIANT}.package-file" ]; then
    echo "copy $TARGET_PRODUCT.${TARGET_BUILD_VARIANT}.package-file ./package-file"
    cp ${TARGET_PRODUCT}.${TARGET_BUILD_VARIANT}.package-file package-file
elif [ -f "$TARGET_PRODUCT.package-file" ]; then
    echo "copy $TARGET_PRODUCT.package-file ./package-file"
    cp $TARGET_PRODUCT.package-file package-file
fi

./afptool -pack ./ Image-$TARGET_PRODUCT/update.img || pause
./rkImageMaker -RK32 Image-$TARGET_PRODUCT/MiniLoaderAll.bin Image-$TARGET_PRODUCT/update.img $TARGET_PRODUCT-rkimage-$BUILD_TAG.img -os_type:androidos || pause
echo "Making $TARGET_PRODUCT-rkimage-$BUILD_TAG.img OK."
openssl dgst -md5 $TARGET_PRODUCT-rkimage-$BUILD_TAG.img
#echo "Press any key to quit:"
#read -n1 -s key
croot
exit 0
