package com.buzztime.tabletprovisioner.model;


public class ManifestPackageInfo extends Object
{
	public String filePath;
	public String path;
	public String fileName;
	public String packageName;
	public String versionName;
	public int versionCode;
	public String url;
	public String md5;

    public ManifestPackageInfo() {
    }

    public ManifestPackageInfo(String filePath, String packageName, String versionName, int versionCode, String md5, String url)
	{
		int slashIndex = filePath.lastIndexOf("/");

		this.path = filePath.substring(0, slashIndex);
		this.fileName = filePath.substring(slashIndex+1);

		this.filePath = filePath;
		this.packageName = packageName;
		this.versionName = versionName;
		this.versionCode = versionCode;
		this.url = url;
		this.md5 = md5;
	}

	public ManifestPackageInfo(String packageName, String versionName, String url)
	{
		this.path = "";
		this.fileName = "";
		this.filePath = "";
		this.packageName = packageName;
		this.versionName = versionName;
		this.versionCode = -1;
		this.url = url;
		this.md5 = "";
	}

	public ManifestPackageInfo(String packageName, String md5) {
		this.path = "";
		this.fileName = "";
		this.filePath = "";
		this.packageName = packageName;
		this.versionName = "";
		this.versionCode = -1;
		this.url = "";
		this.md5 = md5;
	}

	public void parseInternalFilePath( ){
		if (filePath!=null) {
			int slashIndex = filePath.lastIndexOf("/");
			this.path = filePath.substring(0, slashIndex);
			this.fileName = filePath.substring(slashIndex + 1);
		}
	}

	public String toString()
	{
		return "{ filePath:" + filePath + ", path:" + path + ", filename:" + fileName + ", packageName:" +
			"packageName:" + packageName + ", version:" + versionName + ", versionCode:" + versionCode + 
			", md5:" + md5 + ", url:" + url + " }";
	}
	

}

