package com.buzztime.tabletprovisioner.task;

import com.buzztime.tabletprovisioner.soap.miTM;
import com.buzztime.tabletprovisioner.ui.Workspace;
import com.buzztime.tabletprovisioner.util.WorkerThread;

import javax.net.ssl.HttpsURLConnection;
import javax.swing.*;
import java.io.*;
import java.net.MalformedURLException;
import java.net.URL;

/**
 * Created by mstevens on 4/29/16.
 */
public class RequestTabletConfigurationTask extends SwingWorker<Object, Void> {
    private Workspace workspace;
    private JFrame frame;
    String response = "";

    public RequestTabletConfigurationTask(Workspace workspace) {
        this.workspace = workspace;
        frame = workspace;
    }

    @Override
    @WorkerThread
    protected Object doInBackground() throws Exception {
        String soapUrlString = "https://www.howsmyssl.com/";
        System.out.println("request = " + soapUrlString);
        miTM.trustAllHttpsCertificates();

        HttpsURLConnection urlConnection = null;
        StringBuilder str = new StringBuilder();
        DataOutputStream dos = null;
        try {

            URL url = new URL(soapUrlString);
            urlConnection = (HttpsURLConnection) url.openConnection();
            urlConnection.setRequestProperty("Content-Type", "application/json");

        } catch (UnsupportedEncodingException e) {

        } catch (MalformedURLException e) {
            e.printStackTrace();

        } catch (IOException e) {
            e.printStackTrace();
        } finally {
        }

        try {
            int responseCode = urlConnection.getResponseCode();
            System.out.println("response = " + responseCode);

            if (responseCode < 400) {
                BufferedReader r = new BufferedReader(new InputStreamReader(urlConnection.getInputStream()));
                String line = null;
                while ((line = r.readLine()) != null) {
                    str.append(line);
                }

            }

        } catch (IOException e) {
            e.printStackTrace();
        } finally {

        }

        if (urlConnection != null) {
            urlConnection.disconnect();
        }
        response = str.toString();
        System.out.println(response);
        return null;
    }

    @Override
    protected void done() {
        //System.out.println("done:"+frame+","+response);
        if (frame != null)
            JOptionPane.showMessageDialog(frame, "Response" + response);
        workspace.endTask();
    }
}
