/*
 * Copyright (C) 2011 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.buzztime.tabletprovisioner.ui.action;

import com.buzztime.tabletprovisioner.ui.Workspace;

import javax.swing.KeyStroke;
import java.awt.event.KeyEvent;
import java.awt.event.ActionEvent;
import java.awt.Toolkit;

public class DumpDisplayListAction extends BackgroundAction {
    public static final String ACTION_NAME = "dumpDisplayList";
    private Workspace mWorkspace;

    public DumpDisplayListAction(Workspace workspace) {
        putValue(NAME, "Dump DisplayList");
        putValue(SHORT_DESCRIPTION, "Dump DisplayList");
        putValue(LONG_DESCRIPTION, "Dump DisplayList");
        this.mWorkspace = workspace;
    }

    public void actionPerformed(ActionEvent e) {
        executeBackgroundTask(mWorkspace.outputDisplayList());
    }
}
